#-*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""
"""
Original program(html_convert.py) was written by Mr. NAT33. 
Please see the WEB site (http://nat33.web.fc2.com/) about 
html_convert.py
I changed it to adapt to my WEB site.In addition, I added some 
functions for myself. 
(1)Add "make table" module. (2)Add "make image link" module.
(3)Add "shift_jis" out put routine. 
I appreciate to Mr. NAT33.

"""
import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

__script__ = "fubuki2htm"
__version__ = '0.01(1)'
__author__ = 'NAT33 & masa'
__web__ = 'http://masaland.cocolog-nifty.com/ \n http://nat33.web.fc2.com/'
__Copyright__ = ' Copyright (c) 2008 NAT33 & masa'


# config data, chenge here when you need
INI_FILE   = "E:/Data/fubuki2htm.ini"

# config data, change here or INI_FILE
TITLE_TEXT = "masa's WonderLand -Appendix-"
OUT_ENCODE = 0    # select output encoding  0: Shift_JIS  1: UTF-8
BLOG_POST  = 1 # convert for 1: for blog post   0: for web
IMGLINK_TAG  = 1
IN_PATH    = "e:/Data/fubuki"
OUT_PATH   = "e:/Data/fubuki_html"
IMAGE_URL   = "photo/"	# image_file_URL following index.htm_folder
#						  make sure the end "/"
#IMAGE_URL   = "http://masa.la.coocan.jp/blogpt01/photo/"
# /end

#image size notice
# <img1> 400*300     <img4> 240*320      <img>  original size
# <img2> 320*240     <img5> 180*240      <img0>  original size
# <img3> 240*180     <img6> 150*200
#
#example
#<image1>photo/Dscx0010.jpg
#


import re
import os
import appuifw
import e32
lock = e32.Ao_lock()

def br_add ( text ):
    text = text.replace("\r","")
    if BLOG_POST == 1:
        text = text.replace("\n","<br>")
#        pass
    else:
        text = text.replace("\n","<br>\n") 
    text = text.replace("\\n","<br>")  # never add "\n" after <br>, 
#                                      # because "\n" break table
    return text


def get_filename ( text ):
    if text == "FrontPage":  # file_name FrontPage -> index
        return "index.htm"
    str = ""
    for v in text:
        if v == ".":
            if str == "FrontPage": return "index.htm"
            else:                  return str + ".htm"
        str = str + v
    else:
        return str + ".htm"

def get_linkname ( text ):
    if text == "FrontPage":  # file_name FrontPage -> index
        return "index"
    str = ""
    flg = 0
    for v in text:
        if flg == 1:
            str = str + v
        if v == ".":
            flg = 1
    if len(str) == 0:
        str = text
    return str

def link_add ( text ):
    bu1 = '<a href="'
    bu2 = '">'
    bu3 = "</a>"
    
    pattern1 = "[^\[]+\]"
    m_start = re.search(pattern1,text)
    pattern2 = "[^\]]+\]"
    m_end = re.search(pattern2,text)

    while m_start != None and m_end != None:
        pos_start = m_start.start()-1
        pos_end =   m_end.end()

        file_name = get_filename(text[pos_start+1:pos_end-1])
        link_name = get_linkname(text[pos_start+1:pos_end-1])
        
        text = text[:pos_start]+bu1+str(file_name)+bu2+str(link_name)+bu3+text[pos_end:]

        m_start = re.search(pattern1,text)
        m_end = re.search(pattern2,text)
    return text

def title_add ( title , text ):
    text = "<h3>" + title + "</h3>\n" + text
    return text

def head_add ( text ):
    text1 = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">\n'
    text2 = "<html><head><title>%s</title>\n" %TITLE_TEXT
    if OUT_ENCODE == 1:
        text3 = '<META http-equiv="Content-Type" content="text/html; charset=UTF-8">'
    else:
        text3 = '<META http-equiv="Content-Type" content="text/html; charset=Shift_JIS">'
    text4 = '</head>\n<body>'
#    text5 = '<h2 ALIGN="CENTER">'
    text5 = '<h2>'
    text6 = "%s</h2>\n" %TITLE_TEXT
    text7 = '\n</body></html>'
    return text1+text2+text3+text4+text5+text6+text+text7 


def confread():
    global IN_PATH
    global OUT_PATH
    global OUT_ENCODE
    global BLOG_POST
    global IMGLINK_TAG
    global TITLE_TEXT
    global IMAGE_URL
    try:
        f = open(INI_FILE,'r')
        fData = f.read()
        f.close
    except:
        return
        

    lnData=fData.split("\n")
    for i in range(len(lnData)):
        lnDatawk = re.sub("[ \t]+"," ",lnData[i])
        confData = lnDatawk.split(" ")
        if confData[0]   == "IN_PATH"   : IN_PATH    = (confData[1])
        elif confData[0] == "OUT_PATH"  : OUT_PATH   = (confData[1])
        elif confData[0] == "OUT_ENCODE": OUT_ENCODE = int(confData[1])
        elif confData[0] == "BLOG_POST" : BLOG_POST  = int(confData[1])
        elif confData[0] == "IMGLINK_TAG" : IMGLINK_TAG = int(confData[1])
        elif confData[0] == "TITLE_TEXT"  : 
#            confData=lnDatawk.split(" ",1)
#            TITLE_TEXT  = (confData[1])
            TITLE_TEXT = re.sub("TITLE_TEXT[ \t]+","",lnData[i])
        elif confData[0] == "IMAGE_URL"   : IMAGE_URL   = (confData[1])


def set_menu():
    appuifw.app.exit_key_handler = lambda:lock.signal()
    appuifw.app.menu = [(unicode('OK', 'utf-8'),lock.signal )]


def make_table(text,border=1):
    ou_text = ""
    if border > 0:
#        ou_text = '<TABLE border="%d" bordercolor ="gray" align="center">\n' % border
        ou_text = '<TABLE border="%d" bordercolor ="gray">\n' % border
    else:
#        ou_text = '<TABLE bordercolor ="gray" align="center">\n'
        ou_text = '<TABLE bordercolor ="gray">\n'

    text = text.split("\n")
    for line in text:
        ou_text = ou_text + '<TR>'

        line = line.replace("\r","")    ## remove CR from line
        line = line.replace("\n","")    ## remove LF from line
        line = line.replace("\\t","\t") ## convert \t to TAB

        y = line.split("\t")
        for x in y:
            if re.search("<img[0-9]*>",x,2) != None:
                x = re.sub("<[bB][rR]>","",x)
                x = set_img(x)
            ou_text = ou_text + '<TD>%s</TD>' % x
        ou_text = ou_text + '</TR>\n'

    ou_text = ou_text + '</TABLE>'
    return ou_text


def set_img(text):
    if re.search("<img1>",text,2) != None:
        w = 400
        h = 300
    elif re.search("<img2>",text,2) != None:
        w = 320
        h = 240
    elif re.search("<img3>",text,2) != None:
        w = 240
        h = 180
    elif re.search("<img4>",text,2) != None:
        w = 240
        h = 320
    elif re.search("<img5>",text,2) != None:
        w = 180
        h = 240
    elif re.search("<img6>",text,2) != None:
        w = 150
        h = 200
    else:
        w = 0
        h = 0

    text = text.replace("\r","")
    text = text.replace("\n","")

    pre_txt = re.sub("<[iI][mM][gG][0-9]*>.*","",text) #text before "<img.."
#    trail_txt = re.sub(".*[.][gGjJ][iIpP][fFeEgG]+","",text) #text after jpg

    file_pathwk = re.sub(".*<[iI][mM][gG][0-9]*>","",text)

    m_pos = re.search("[.][gGjJ][iIpP][fFeEgG]+",file_pathwk) # xxxxx.jp(e)g
    pos_end =   m_pos.end()
    file_name = file_pathwk[:pos_end]
    trail_txt = file_pathwk[pos_end:] #text after "...jp(e)g"

    file_path = IMAGE_URL + file_name

    if w != 0:
        txt = '<img src="%s" alt="%s" border="1" width="%d" hight="%d">' \
				 %(file_path,file_name,w,h)
    else:
        txt = '<img src="%s" alt="%s" border="1">' %(file_path,file_name)

    if IMGLINK_TAG == 1:
        link_tag = '<A href="%s" target="_blank">' %(file_path)
        txt = link_tag + txt + '</A>'
    return  pre_txt + txt + trail_txt + '\n\n'



def html_convert ( in_path , out_path ):
    file_list = [x for x in os.listdir(in_path)]
    file_list.sort()
    for x in file_list:
        if x != "fubukilog":
            f = open(in_path+'/'+x, 'r')
            out_text = ""

            kei_text = ""
            tflg = 0
            for line in f:
                if tflg == 0:
                    if re.search("<table>",line,2) != None :
                        tflg = 1
                    else:
                        if re.search("<img[0-9]*>",line,2) != None:
                            line = set_img(line)
                        out_text = out_text + link_add(br_add(line))
                else:
                    if re.search("</table>",line,2) != None :
                        tflg = 0
                        out_text = out_text + make_table(kei_text)
                    else:
                        kei_text = kei_text + link_add(br_add(line))

            if x == 'FrontPage': x = 'index' # file_name FrontPage -> index
            if BLOG_POST != 1:
                out_text = title_add(x,out_text)
                out_text = head_add(out_text)
            f.close()

            file_name = get_filename(x)

            f = open(out_path+'/'+str(file_name), 'w')

##  convert utf-8 to shift_jis
            if OUT_ENCODE == 0:
                out_text = out_text.replace("\r","")
                out_text = out_text.replace("\n","\r\n")
                out_text = unicode(out_text,'utf-8')
                out_text = out_text.encode('japanese.shift_jis')
##

            f.write(out_text)
            f.close()


def disp_msg(msg,fontsize='dense'):
    body = appuifw.Text()
    appuifw.app.body = body
    body.color = 0x000000
    body.font = fontsize
    body.add(unicode(str(msg),'utf-8'))



def main():
    confread()
    old_title = appuifw.app.title
    appuifw.app.title = unicode(__script__)
    msg = ''
    msg = '\n  ** Processing **'
    disp_msg(msg,fontsize='normal')
    e32.ao_sleep(0.1,) # change screen
#    appuifw.note(unicode("** Processing **"), "info")

    set_menu()

    try:
        html_convert ( IN_PATH , OUT_PATH )
        msg = msg + '\n  ** Complete **'
        disp_msg(msg,fontsize='normal')
#        idx = appuifw.query(unicode("Complete"), "query")
    except:
        msg = msg + '\n  ** Error **\nPlease check used char '
        disp_msg(msg,fontsize='normal')
#        idx = appuifw.query(unicode("Error  \nPls check used char "), "query")

    lock.wait()
    appuifw.app.title = old_title

if __name__ == "__main__":
    main()
#    sys.exit()